#!/usr/bin/env php
<?php
/**
 * Copyright © 2017 Robertas Dereskevicius <info@softdb.eu>, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

$replaceExisting = true;
$deleteFromDirAfterAdd = true;

if (PHP_SAPI !== 'cli') {
    echo 'bin/magento must be run as a CLI application';
    exit(1);
}

try {
    require __DIR__ . '/../app/bootstrap.php';
} catch (\Exception $e) {
    echo 'Autoload error: ' . $e->getMessage();
    exit(1);
}


	if (count($_SERVER["argv"]) != 2 || !is_dir($_SERVER["argv"][1]))
	    die("Import Images Dir not found..\n");


	$bootstrap = \Magento\Framework\App\Bootstrap::create(BP, $_SERVER);
	/** @var \Magento\Framework\ObjectManager\ObjectManager $objectManager */
	$objectManager = $bootstrap->getObjectManager();
	$objectManager->get('\Magento\Framework\App\State')->setAreaCode('frontend');

	$mediaGalleryProcessor = $objectManager->get('Magento\Catalog\Model\Product\Gallery\Processor');
        $resourceConnection = $objectManager->create('\Magento\Framework\App\ResourceConnection');
        $connection = $resourceConnection->getConnection();

	$tblProduct = $connection->getTableName('catalog_product_entity');
	$tblProductVarchar = $connection->getTableName('catalog_product_entity_varchar');

        $eavAttribute = $objectManager->get("\Magento\Eav\Model\ResourceModel\Entity\Attribute");
        $attributeIdBarcode = $eavAttribute->getIdByCode('catalog_product', 'barcode');
        if (!$attributeIdBarcode) die ("Product attribute 'barcode' not found\n");


	$dir = $_SERVER["argv"][1];

        $d = dir($dir);
	$files = array();
        while (false !== ($entry = $d->read())) {
	    if($entry != '.' && $entry != '..' && !is_dir($dir.$entry))
        	    $files[] = $entry;
	}
        $d->close();

	$updated = 0;
	$images = array();
	foreach ($files as $file) {
	    if(@is_array(getimagesize($dir."/".$file))){
		$main = true;
		$ext = @end(explode('.', $file));
		$sku = substr($file, 0 , strlen($file)-strlen($ext)-1);
	        //$query = "select entity_id from ".$tblProduct." where sku='".addslashes($sku)."'";
	        $query = "select entity_id from ".$tblProductVarchar." where attribute_id='".$attributeIdBarcode."' and value='".addslashes($sku)."'";
	        $entity_id = $connection->fetchOne($query);
		if (!$entity_id) {
		    $arr = explode("_",$sku);
		    if (count($arr)>=2) {
			$main = false;
			$ext = end($arr);
			$sku = substr($sku, 0 , strlen($sku)-strlen($ext)-1);
		        //$query = "select entity_id from ".$tblProduct." where sku='".addslashes($sku)."'";
    	    		$query = "select entity_id from ".$tblProductVarchar." where attribute_id='".$attributeIdBarcode."' and value='".addslashes($sku)."'";
		        $entity_id = $connection->fetchOne($query);
		    }
		}
		if (!$entity_id) {
		    echo "Product with barcode '$sku' not found. File '$file' skipping\n";
		} else {
	            /** @var \Magento\Framework\Filesystem $filesystem */
	            $filesystem = $objectManager->create('Magento\Framework\Filesystem');
	            /** @var \Magento\Framework\Filesystem\Directory\WriteInterface $mediaDirectory */
	            $mediaDirectory = $filesystem->getDirectoryWrite(\Magento\Framework\App\Filesystem\DirectoryList::MEDIA);
	            $mediaPath = $mediaDirectory->getAbsolutePath();

		    copy(realpath($dir)."/".$file,$mediaPath."import/$file");
		    $product = $objectManager->create('Magento\Catalog\Model\Product')->load($entity_id);

		    $images = $product->getMediaGalleryImages();
		    $found = false;
		    foreach($images as $child){
//print "<pre>";print_r($child);//exit;
			if (basename($child->getFile()) == $file) $found=true;
//print "$found ".basename($child->getFile())." == $file\n";
			if ($found && $replaceExisting) {
				$mediaGalleryProcessor->removeImage($product, $child->getFile());
				$product->save();
				break;
			}
		    }   

		    $product = $objectManager->create('Magento\Catalog\Model\Product')->load($entity_id);

//exit;
		    if ($main) {
			if (!$found || $replaceExisting) {
			    $product->addImageToMediaGallery("import/".$file, array('image', 'small_image', 'thumbnail'), true, false);
			    $updated++;
			    if ($deleteFromDirAfterAdd)
				@unlink(realpath($dir)."/".$file);
			}
		    } else {
			if (!$found || $replaceExisting) {
			    $product->addImageToMediaGallery("import/".$file, null, true, false);
			    $updated++;
			    if ($deleteFromDirAfterAdd)
				@unlink(realpath($dir)."/".$file);
			}
		    }
		    $product->save();
		}
	    } else {
		echo "File '$dir/$file' is not image\n";
	    }
	}

echo "Updated $updated product images\n";




